SystemOrganization addCategory: #ConfigurationOfPharoBot!

Object subclass: #ConfigurationOfPharoBot
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharoBot'!

!ConfigurationOfPharoBot commentStamp: '<historical>' prior: 0!
Metacello Configuration for PharoBot

Dependencies:
  * Glamour!

!ConfigurationOfPharoBot class methodsFor: 'development support' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPharoBot class methodsFor: 'private' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPharoBot class methodsFor: 'private' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPharoBot class methodsFor: 'private' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPharoBot class methodsFor: 'metacello tool support' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharoBot class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPharoBot class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPharoBot class methodsFor: 'loading' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPharoBot class methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
project

	^self new project! !

!ConfigurationOfPharoBot class methodsFor: 'development support' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPharoBot methodsFor: 'baselines' stamp: 'NahuelGarbezza 8/25/2012 23:31'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/PharoBot'.
		spec project: 'Glamour' with: [
				spec
					className: 'ConfigurationOfGlamour';
					versionString: #'default';
					repository: 'http://www.squeaksource.com/Glamour' ].
		spec 
			package: 'PharoBot-Core';
			package: 'PharoBot-Core-Tests'
				with: [ spec requires: #('PharoBot-Core') ];
			package: 'PharoBot-Environment'
				with: [	spec requires: #('PharoBot-Core') ];
			package: 'PharoBot-Environment-Tests'
				with: [	spec requires: #('PharoBot-Environment') ];
			package: 'PharoBot-UI' with: [ spec requires: #('PharoBot-Core' 'Glamour') ].
		spec 
			group: 'default' with: #('PharoBot-Core' 'PharoBot-Environment' 'PharoBot-UI' );
			group: 'Tests' with: #('default' 'PharoBot-Core-Tests' 'PharoBot-Environment-Tests') ].! !

!ConfigurationOfPharoBot methodsFor: 'symbolic versions' stamp: 'NahuelGarbezza 1/30/2012 15:38'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfPharoBot methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/30/2012 15:37'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPharoBot methodsFor: 'versions' stamp: 'NahuelGarbezza 8/25/2012 23:32'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'NahuelGarbezza'.
		spec timestamp: '8/25/2012 23:32'.
		spec project: 'Glamour' with: #'stable'.
		spec 
			package: 'PharoBot-Core' with: 'PharoBot-Core';
			package: 'PharoBot-Core-Tests' with: 'PharoBot-Core-Tests';
			package: 'PharoBot-Environment' with: 'PharoBot-Environment';
			package: 'PharoBot-Environment-Tests' with: 'PharoBot-Environment-Tests';
			package: 'PharoBot-UI' with: 'PharoBot-UI'. ].
! !
